###############################################################################
#
#                 Rainmeter installer script for NSIS
#                           version 0.4
#
###############################################################################

#
# Variables
#
Name "Rainmeter 0.13"
OutFile "Rainmeter-0.13-32bit.exe"
InstallDir "$PROGRAMFILES\Rainmeter"
InstallDirRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Rainmeter" ""
XPStyle on

Page license
Page components
Page directory
Page instfiles

LicenseData "license.txt"

#
# Components
#
ComponentText "Select the installing options"

#
# Install
#
Section "Rainmeter main program" ; (default section)
  SetOutPath "$INSTDIR"
  SectionIn 1 RO

RainmeterCheckAgain:
  FindWindow $0 "RainmeterTrayClass"
  IsWindow $0 0 RainmeterDoesntExistLabel
    MessageBox MB_ABORTRETRYIGNORE|MB_ICONSTOP "Please close Rainmeter before you proceed." IDRETRY RainmeterCheckAgain IDIGNORE RainmeterDoesntExistLabel
    Abort
    
RainmeterDoesntExistLabel:

  IfFileExists $INSTDIR\Rainmeter.ini FileExitsLabel
  Goto OverWriteAllLabel
  
FileExitsLabel:
  MessageBox MB_YESNO|MB_ICONQUESTION "Do you want to keep your old settings?" IDNO OverWriteAllLabel
  
  Rename $INSTDIR\Rainmeter.ini $INSTDIR\Rainmeter.old
  File /r "Distrib\*.*"
  Delete $INSTDIR\Rainmeter.ini
  Rename $INSTDIR\Rainmeter.old $INSTDIR\Rainmeter.ini
  Goto DoneLabel

OverWriteAllLabel:
  File /r "Distrib\*.*"
  
DoneLabel:

  WriteRegStr HKEY_LOCAL_MACHINE "SOFTWARE\Rainmeter" "" "$INSTDIR"
  WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\Rainmeter" "DisplayName" "Rainmeter (remove only)"
  WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\Rainmeter" "UninstallString" '"$INSTDIR\uninst.exe"'
  
  WriteUninstaller "$INSTDIR\uninst.exe"

SectionEnd ; end of default section

Section "Add shortcuts to Start-menu"
  # Shortcut on Start Menu (Directory and Uninstall)
  CreateDirectory "$SMPROGRAMS\Rainmeter"
  CreateShortCut  "$SMPROGRAMS\Rainmeter\Rainmeter.lnk" "$INSTDIR\Rainmeter.exe" "" "$INSTDIR\Rainmeter.exe" 0
  CreateShortCut  "$SMPROGRAMS\Rainmeter\Help.lnk" "$INSTDIR\Rainmeter.chm" "" "$INSTDIR\Rainmeter.chm" 0
  CreateShortCut  "$SMPROGRAMS\Rainmeter\Remove Rainmeter.lnk" "$INSTDIR\uninst.exe" "" "$INSTDIR\uninst.exe" 0
SectionEnd

Section "Add shortcut to desktop"
  SectionIn 1
  CreateShortCut  "$DESKTOP\Rainmeter.lnk" "$INSTDIR\Rainmeter.exe" "" "$INSTDIR\Rainmeter.exe" 0
SectionEnd

Section "Add shortcut to startup folder"
  SectionIn 1
  CreateShortCut  "$SMSTARTUP\Rainmeter.lnk" "$INSTDIR\Rainmeter.exe" "" "$INSTDIR\Rainmeter.exe" 0
SectionEnd

#
# Uninstall
#
UninstallText "This will uninstall Rainmeter from your system.$\nMake sure that Rainmeter is not running before proceeding."

Section Uninstall

RainmeterCheckAgain2:
  FindWindow $0 "RainmeterTrayClass"
  IsWindow $0 0 RainmeterDoesntExistLabel2
    MessageBox MB_ABORTRETRYIGNORE|MB_ICONSTOP "Please close Rainmeter before you proceed." IDRETRY RainmeterCheckAgain2 IDIGNORE RainmeterDoesntExistLabel2
    Abort

RainmeterDoesntExistLabel2:

  Delete "$INSTDIR\Skins\Tranquil\Bar\*.*"
  Delete "$INSTDIR\Skins\Tranquil\Clock\*.*"
  Delete "$INSTDIR\Skins\Tranquil\News\*.*"
  Delete "$INSTDIR\Skins\Tranquil\System\*.*"
  Delete "$INSTDIR\Skins\Tranquil\Weather\*.*"
  Delete "$INSTDIR\Skins\Tranquil\*.*"
  Delete "$INSTDIR\Plugins\*.*"
  Delete "$INSTDIR\*.*"
  RMDir "$INSTDIR\Skins\Tranquil\Bar"
  RMDir "$INSTDIR\Skins\Tranquil\Clock"
  RMDir "$INSTDIR\Skins\Tranquil\News"
  RMDir "$INSTDIR\Skins\Tranquil\System"
  RMDir "$INSTDIR\Skins\Tranquil\Weather"
  RMDir "$INSTDIR\Skins\Tranquil"
  RMDir "$INSTDIR\Skins"
  RMDir "$INSTDIR\Plugins"
  DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Rainmeter"
  DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Rainmeter"
  RMDir "$INSTDIR"
  Delete "$SMSTARTUP\Rainmeter.lnk"
  Delete "$DESKTOP\Rainmeter.lnk"
  Delete "$SMPROGRAMS\Rainmeter\*.*"
  RMDir "$SMPROGRAMS\Rainmeter"
  
  IfFileExists "$INSTDIR" 0 NoErrorMsg
    MessageBox MB_OK "Note: $INSTDIR could not be removed!" IDOK 0 ; skipped if file doesn't exist
  NoErrorMsg:
  
SectionEnd

; eof
